<?php
/**
 * malCure Malware Removal & Firewall
 *
 * @package     malCure Malware Removal & Firewall
 * @author      Shivanand Sharma
 * @copyright   2019 wp-malware-removal.com
 * @license     MIT
 *
 * @wordpress-plugin
 * Plugin Name: malCure Malware Removal & Firewall
 * Description: Ultra-precision, comphrensive malware scanner and firewall to protect your site and find viruses, infections & other security threats & vulnerabilities.
 * Version:     3.4
 * Author:      Shivanand Sharma
 * Author URI:  https://wp-malware-removal.com
 * Text Domain: wpmr
 * License:     MIT
 * License URI: https://opensource.org/licenses/MIT
 * Plugin URI:  https://wp-malware-removal.com
 */

/*

███╗   ███╗ █████╗ ██╗      ██████╗██╗   ██╗██████╗ ███████╗    ███╗   ███╗ █████╗ ██╗     ██╗    ██╗ █████╗ ██████╗ ███████╗    ███████╗ ██████╗ █████╗ ███╗   ██╗███╗   ██╗███████╗██████╗ 
████╗ ████║██╔══██╗██║     ██╔════╝██║   ██║██╔══██╗██╔════╝    ████╗ ████║██╔══██╗██║     ██║    ██║██╔══██╗██╔══██╗██╔════╝    ██╔════╝██╔════╝██╔══██╗████╗  ██║████╗  ██║██╔════╝██╔══██╗
██╔████╔██║███████║██║     ██║     ██║   ██║██████╔╝█████╗      ██╔████╔██║███████║██║     ██║ █╗ ██║███████║██████╔╝█████╗      ███████╗██║     ███████║██╔██╗ ██║██╔██╗ ██║█████╗  ██████╔╝
██║╚██╔╝██║██╔══██║██║     ██║     ██║   ██║██╔══██╗██╔══╝      ██║╚██╔╝██║██╔══██║██║     ██║███╗██║██╔══██║██╔══██╗██╔══╝      ╚════██║██║     ██╔══██║██║╚██╗██║██║╚██╗██║██╔══╝  ██╔══██╗
██║ ╚═╝ ██║██║  ██║███████╗╚██████╗╚██████╔╝██║  ██║███████╗    ██║ ╚═╝ ██║██║  ██║███████╗╚███╔███╔╝██║  ██║██║  ██║███████╗    ███████║╚██████╗██║  ██║██║ ╚████║██║ ╚████║███████╗██║  ██║
╚═╝     ╚═╝╚═╝  ╚═╝╚══════╝ ╚═════╝ ╚═════╝ ╚═╝  ╚═╝╚══════╝    ╚═╝     ╚═╝╚═╝  ╚═╝╚══════╝ ╚══╝╚══╝ ╚═╝  ╚═╝╚═╝  ╚═╝╚══════╝    ╚══════╝ ╚═════╝╚═╝  ╚═╝╚═╝  ╚═══╝╚═╝  ╚═══╝╚══════╝╚═╝  ╚═╝
                                                                                                                                                                                             
          ██████╗ ██╗   ██╗    ███████╗██╗  ██╗██╗██╗   ██╗                                                                                                                                  
          ██╔══██╗╚██╗ ██╔╝    ██╔════╝██║  ██║██║██║   ██║                                                                                                                                  
█████╗    ██████╔╝ ╚████╔╝     ███████╗███████║██║██║   ██║                                                                                                                                  
╚════╝    ██╔══██╗  ╚██╔╝      ╚════██║██╔══██║██║╚██╗ ██╔╝                                                                                                                                  
          ██████╔╝   ██║       ███████║██║  ██║██║ ╚████╔╝                                                                                                                                   
          ╚═════╝    ╚═╝       ╚══════╝╚═╝  ╚═╝╚═╝  ╚═══╝                                                                                                                                    
                                                                                                                                                                                             
*/


define( 'WPMR_PLUGIN_DIR_URL', trailingslashit( plugin_dir_url( __FILE__ ) ) );
define( 'WPMR_SERVER', 'https://wp-malware-removal.com/' );
define( 'WPMR_PLUGIN', __FILE__ );
define( 'WPMR_PLUGIN_DIR', trailingslashit( __DIR__ ) );

final class WPMR_Init {

	private $definitions;
	private $flag;
	public $dir;
	public $url;

	static function get_instance() {
		static $instance = null;
		if ( is_null( $instance ) ) {
			$instance = new self();
			$instance->init();
		}
			return $instance;
	}

	function init() {

		$this->dir = trailingslashit( plugin_dir_path( __FILE__ ) );
		$this->url = trailingslashit( plugin_dir_url( __FILE__ ) );

		// register_activation_hook( WPMR_PLUGIN, array( $this, 'activate' ) );

		if ( ! wp_next_scheduled( 'wpmr_hourly' ) ) {
			wp_schedule_event( time(), 'hourly', 'wpmr_hourly' );
		}

		register_deactivation_hook( WPMR_PLUGIN, array( $this, 'deactivate' ) );

		add_action( 'wpmr_hourly', array( $this, 'check_definitions' ) );

		add_action( 'admin_init', array( $this, 'upgrade' ) );

		add_action( 'upgrader_process_complete', array( $this, 'delete_checksums' ), 9999, 2 );

		add_action( 'admin_init', array( $this, 'set_plugin_data' ) );
        add_action( 'admin_init', array( $this, 'save_gsc_profile' ) );
        add_action( 'admin_init', array($this, 'register_settings') );

		add_action( 'admin_notices', array( $this, 'admin_notice' ) );

		add_filter( 'plugin_action_links_' . plugin_basename( WPMR_PLUGIN ), array( $this, 'plugin_action_links' ) );
		add_filter( 'plugin_row_meta', array( $this, 'plugin_meta_links' ), 10, 2 ); // Add important links to plugins list (right-side)

		add_action( 'admin_enqueue_scripts', array( $this, 'plugin_styles' ) );
		add_action( 'admin_menu', array( $this, 'settings_menu' ) );

		// add_filter( 'cron_schedules', array($this, 'check_definitions' ) );
		add_action( 'wp_ajax_wpmr_init_scan', array( $this, 'wpmr_init_scan' ) );
		add_action( 'wp_ajax_wpmr_scan_files', array( $this, 'wpmr_scan_files' ) );
		add_action( 'wp_ajax_wpmr_inspect_file', array( $this, 'wpmr_inspect_file' ) );

		add_action( 'wp_ajax_wpmr_update_sigs', array( $this, 'update_definitions' ) );
		add_action( 'wp_ajax_wpmr_register', array( $this, 'wpmr_register' ) );

		add_action( 'wp_ajax_nopriv_wpmr_inspect_file', '__return_false' );
		add_action( 'wp_ajax_nopriv_wpmr_init_scan', '__return_false' );
		add_action( 'wp_ajax_nopriv_wpmr_scan_files', '__return_false' );
		add_action( 'wp_ajax_nopriv_wpmr_check_files', '__return_false' );
		add_action( 'wp_ajax_nopriv_wpmr_update_sigs', '__return_false' );
		add_action( 'wp_ajax_nopriv_wpmr_register', '__return_false' );

		add_action( 'admin_footer', array( $this, 'scripts' ) );

		add_action( 'load-toplevel_page_wpmr', array( $this, 'load_meta_boxes' ) );
		add_action( 'load-toplevel_page_wpmr', array( $this, 'add_meta_boxes' ) );
		add_action( 'load-toplevel_page_wpmr', array( $this, 'add_admin_scripts' ) );
		add_action( 'admin_head', array( $this, 'admin_style' ) );
		add_action( 'in_plugin_update_message-' . basename( WPMR_PLUGIN_DIR ) . '/' . basename( WPMR_PLUGIN ), array( $this, 'plugin_update_message' ), 10, 2 );
        add_action( 'plugins_loaded', array( $this, 'waf' ), -1 );
	}

	private function __construct() {
	}

	function activate() {
		if ( ! wp_next_scheduled( 'wpmr_hourly' ) ) {
			wp_schedule_event( time(), 'hourly', 'wpmr_hourly' );
		}
	}

	function deactivate() {
		wp_clear_scheduled_hook( 'wpmr_hourly' );
	}

	function upgrade() {
		$reg = get_option( 'WPMR_reg' );
		if ( $reg ) {
			if ( $this->update_setting( 'user', $reg ) ) {
				delete_option( 'WPMR_reg' );
			}
		}
	}

	function definition_updates_available() {
		$current = $this->get_setting( 'signatures' )['v'];
		$new     = $this->get_setting( 'update-version' );

		if ( $current != $new ) {
			return array(
				'new'     => $new,
				'current' => $current,
			);
		}
	}

	function admin_notice() {
		$updates = $this->definition_updates_available();
		if ( $updates ) { ?>
		<div class="notice notice-error">
			<p><?php _e( '<strong>malCure Malware Removal &amp; Firewall:</strong> New Definition Updates Are Available. You have version ' . $updates['current'] . ' Latest version is ' . $updates['new'] . ' <a href="' . get_admin_url( null, 'admin.php?page=wpmr' ) . '#wpmr-updates-box">Update Now!</a>', 'wpmr' ); ?>
			</p>
		</div>
			<?php
		}
	}

	function load_meta_boxes() {
		add_action( 'add_meta_boxes', array( $this, 'wpmr_add_metaboxes' ) );
	}

	function wpmr_add_metaboxes() {
		
        add_meta_box( 'wpmr-results-box', 'Status Details', array( $this, 'meta_box_results' ), 'toplevel_page_wpmr', 'main', 'high' );
        add_meta_box( 'wpmr-debug-box', 'Advanced Options', array( $this, 'meta_box_debug' ), 'toplevel_page_wpmr', 'main', 'high' );
		add_meta_box( 'wpmr-inspect-box', 'File Inspector', array( $this, 'meta_box_inspect' ), 'toplevel_page_wpmr', 'main', 'high' );
		add_meta_box( 'wpmr-diagnostics-box', 'System Status', array( $this, 'meta_box_diagnostics' ), 'toplevel_page_wpmr', 'main', 'high' );
		add_meta_box( 'wpmr-updates-box', 'Updates', array( $this, 'meta_box_updates' ), 'toplevel_page_wpmr', 'side', 'high' );
		add_meta_box( 'wpmr-tools-box', 'Important Resources', array( $this, 'meta_box_wpmrtools' ), 'toplevel_page_wpmr', 'side', 'high' );
		add_meta_box( 'wpmr-support-box', 'About malCure Malware Removal &amp; Firewall', array( $this, 'meta_box_support' ), 'toplevel_page_wpmr', 'side', 'high' );
	}

    function meta_box_debug(){
        ?>
        <p>Skip the following directories (comma-separated):</p>
        <p><input type="text" name="skipdirs" id="skipdirs" class="widefat" /></p>
        <input type="checkbox" name="show_suspicious" checked id="show_suspicious"/> <label for="show_suspicious">Paranoia-Mode: Show potential, even loosly-suspicious matches, scan even images, skip no file-types (except for the above folder)?</label>
        <?php
    }

	function add_meta_boxes() {
		do_action( 'add_meta_boxes', 'toplevel_page_wpmr', '' );
	}

	function meta_box_updates() {
		?>
		<div class="wpmr-updates">
			<table id="server">
				<tr>
					<th>Definitions:</th>
					<td><?php echo $this->get_setting( 'signatures' )['v']; ?></td>
				</tr>
				<tr>
					<th>Last Updated:</th>
					<td id="last_updated">
						<?php
							echo $this->get_last_updated_ago();
						?>
					</td>
				</tr>
			</table>
			<?php
			if ( $this->is_registered() ) {
				if ( $this->definition_updates_available() ) {
					echo '<p style="color:#c00;font-weight: bold;">New Definition Updates Are Available.</p><table class="def-updates"><tr><th>Current:</th><td>' . $this->get_setting( 'signatures' )['v'] . '</td></tr><tr><th>New:</th><td>' . $this->get_setting( 'update-version' ) . '</td></tr></table>';
				}
				submit_button( 'Update Definitions', 'primary', 'wpmr-update' );
				$reg       = $this->get_setting( 'user' );
				$statevars = $this->encode( array_merge( $this->get_diag_data(), $reg ) );
				echo '<div id="is_registered">';
				if ( empty( $reg['gsc'] ) ) {
					echo '<p style="border-top: 2px solid #ccc; padding: 1em 0"><strong>Connect to Google Search Console to get timely security alerts.</strong></p>';
					echo '<a class="button-primary" href="' . WPMR_SERVER . '?p=495&wpmr_authenticate=' . $statevars . '">Authenticate with Google Search Console</a>';
				}
				echo '</div>';
			} else {
                echo '<div id="is_unregistered"><h3 style="border-top: 2px solid #ccc; padding: 1em 0 0; line-height: 1.618em;"><strong>Malware definitions out of date!</strong></h3>
                <p>A free registration is required to pass the security check and update to the latest malware definitions.</p>';
				$current_user = wp_get_current_user();
				?>
			<form id="wpmp_reg_form">
				<table id="wpmr_reg">
					<tr>
						<td>First name</td>
						<td><input type="text" name="wpmr_fn" id="wpmr_fn" required
								value="<?php echo empty($current_user->user_firstname) ? empty( $current_user->nickname ) ? $current_user->user_login : $current_user->nickname : $current_user->user_firstname; ?>" /></td>
					</tr>
					<tr>
						<td>Last name</td>
						<td><input type="text" name="wpmr_ln" id="wpmr_ln" required
								value="<?php echo empty($current_user->user_lastname) ? empty( $current_user->nickname ) ? $current_user->user_login : $current_user->nickname : $current_user->user_lastname; ?>" /></td>
					</tr>
					<tr>
						<td>Email</td>
						<td><input type="email" name="wpmr_eml" id="wpmr_eml" required
								value="<?php echo $current_user->user_email; ?>" /></td>
					</tr>
					<tr>
						<td>Site</td>
						<td><input type="URL" readonly name="wpmr_url" id="wpmr_url" required
								value="<?php echo site_url(); ?>" /></td>
					</tr>
					<tr>
						<td>Your free key:</td>
						<td><input type="text" readonly name="wpmr_key" id="wpmr_key" required
								value="<?php echo md5( site_url() ); ?>" /></td>
					</tr>
				</table>
			</form>
			<script type="text/javascript">
			jQuery(document).ready(function($) { //wrapper
				$("#wpmr-register").click(function(e) {
					e.preventDefault();
					if (!document.querySelector('#wpmp_reg_form').reportValidity()) {
						return false;
					}
					wpmr_register = {
						wpmr_register_nonce: '<?php echo wp_create_nonce( 'wpmr_register' ); ?>',
						action: "wpmr_register",
						cachebust: Date.now(),
						user: {
							fn: $('#wpmr_fn').val(),
							ln: $('#wpmr_ln').val(),
							email: $('#wpmr_eml').val(),
							key: $('#wpmr_key').val()
						}
					};

					$.ajax({
						url: ajaxurl,
						method: 'POST',
						data: wpmr_register,
						complete: function(jqXHR, textStatus) {},
						success: function(response) {
							//console.dir(response);
							if ((typeof response) != 'object') {
								response = JSON.parse(response);
							}
							if (response.hasOwnProperty('success')) {
								$('#is_unregistered').html(
									'<p><strong>Thank you for registering!</strong></p>');
								location.reload(true);
							} else {
								$('#reg_error').html('<p><strong>' + response.error +
									'</strong></p>');
							}
						} // initialize
					}); // ajax post
					return false;
				});
			});
			</script>
				<?php
				echo '<div id="reg_error"></div>';
                echo '<p>';
                submit_button( 'Register &rarr;', 'primary', 'wpmr-register', false );
                submit_button( 'Cancel', 'secondary', 'wpmr-register-cancel', false );
                echo '</p>';
                echo '</div>';
			}
			?>
		</div>
		<?php
	}

	function meta_box_wpmrtools() {
		$domain = untrailingslashit( preg_replace( '/https?:\/\//', '', get_site_url() ) );
		$domain = explode( '/', $domain )[0];
		?>
		<ul class="wpmr_tools">
			<li><a href="https://wp-malware-removal.com/?utm_source=wpmr"><span class="dashicons dashicons-admin-home"></span> Plugin Homepage</a></li>
			<li><a href="https://wp-malware-removal.com/?p=44&utm_source=wpmr"><span class="dashicons dashicons-info"></span> Malware Clean-Up Support</a></li>
			<li><a href="mailto:support@wp-malware-removal.com"><span class="dashicons dashicons-tickets-alt"></span> Create a Ticket</a></li>
			<li><a href="https://wordpress.org/support/plugin/wp-malware-removal/reviews/"><span class="dashicons dashicons-star-filled"></span> Rate Us!</a></li>
		</ul>
		<?php
		echo '
        <p><strong>Click on any of the links below to run your site through the tool.</strong> All links open in new tab / window.</p>
        <p><strong>Note:</strong> malCure Malware Removal &amp; is not affiliated with any of these sites.</p>
        <ol>
        <li><a id="tool" target="_blank" href="https://www.google.com/transparencyreport/safebrowsing/diagnostic/index.html#url=' . get_site_url() . '">Google Safe Browsing Diagnostic</a></li>
        <li><a id="tool" target="_blank" href="https://sitecheck.sucuri.net/results/' . get_site_url() . '">Sucuri Website Malware Scanner</a></li>
        <li><a id="tool" target="_blank" href="https://www.virustotal.com/#/domain/' . $domain . '">VirusTotal Analyzer</a><br></li>
        <li><a id="tool" target="_blank" href="https://tools.geekflare.com/report/screenshot/' . get_site_url() . '">Geek Flare Screenshot Checker</a></li>
        <li><a id="tool" target="_blank" href="https://tools.geekflare.com/report/blacklist-test/' . get_site_url() . '">Geek Flare Blacklist Test</a></li>
        <li><a id="tool" target="_blank" href="https://geopeeker.com/fetch/?url=' . get_site_url() . '">GeoPeeker Peek Results</a><br></li>
        <li><a id="tool" target="_blank" href="https://tools.geekflare.com/report/dnssec-test/' . get_site_url() . '">Geek Flare DNSSEC Test</a></li>
        <li><a id="tool" target="_blank" href="https://tools.geekflare.com/report/https-test/' . get_site_url() . '">Geek Flare HTTP/2 Test</a></li>
        </ol>
        ';
	}

	function meta_box_results() {
		$info = get_bloginfo();
		?>
		<div class="scan-results">
        <?php if( ! $this->is_registered() ) {
            echo '<h4 style="color: red;">Out of date definitions. Can\'t do a thorough scan. Please register for free to update definitions.</h4>';
        } ?>
			<h3>Database Scan Results:</h3>
			<div id="db-results"></div>
			<h3>WordPress Scan Results:</h3>
			<div id="file-results"></div>
			<div id="wpmr-what-to-do">
				<p><strong>LEGEND:</strong> 
				<span class="skipped legend threat" title="This file could not be read">Error reading file</span>
				<span class="suspicious legend threat" title="This file is probably suspicious">Suspicious File</span>
				<span class="severe legend threat" title="This file is a severe threat">Severe Infection</span></p>
                <?php if( ! $this->is_registered() ) {
                    echo '<h3 style="color: red;" class="blink">Many types of malware can\'t be detected because the definitions are out-of-date. There could be other types of malware. Please register for free and update definitions to do a thorough scan.</h3>';
                } ?>
				<h1>What to do in case of malware infection:</h1>
				<ol>
					<li>
						<strong>Please do manual investigation before deleting any files blindly.</strong>
					</li>
					<li>
						<strong>In case of any possible infection, put your site into maintenance mode, take full backup and <a href="https://wp-malware-removal.com/?p=44&utm_source=wpmr" target="_blank">file malware clean-up request</a>.</strong>
					</li>
				</ol>
				<p><strong><a href="https://wp-malware-removal.com/?p=44&utm_source=wpmr" target="_blank" class="button-primary">File malware clean-up request</a></strong></p>
				<p><strong><a href="https://twitter.com/shivtwin" target="_blank" class="button-secondary">Connect on Twitter</a></strong></p>
			</div>
		</div>
		<?php
	}

	function meta_box_inspect() {
		?>
		<span id="inspect_file_path"></span>
		<textarea readonly id="inspect_file"></textarea>
		<a href="#wpmr-results-box" class="button-primary wpmr-back">Go Back to Results</a>
		<?php
	}

	function meta_box_diagnostics() {
		?>
		<table id="system-status">
		<tr>
			<th>Website URL</th>
			<td><?php echo get_bloginfo( 'url' ); ?></td>
		</tr>
		<tr>
			<th>WP URL</th>
			<td><?php echo get_bloginfo( 'wpurl' ); ?></td>
		</tr>
		<tr>
			<th>WP Installation DIR</th>
			<td><?php echo ABSPATH; ?></td>
		</tr>
		<tr>
			<th>WP Version</th>
			<td><?php echo get_bloginfo( 'version' ); ?></td>
		</tr>
		<tr>
			<th>WP Language</th>
			<td><?php echo get_bloginfo( 'language' ); ?></td>
		</tr>
		<tr>
			<th>WP Multisite:</th>
			<td><?php echo is_multisite() ? 'Yes' : 'No'; ?></td>
		</tr>
		<tr>
			<th>Active Theme</th>
			<td><?php echo get_bloginfo( 'stylesheet_directory' ); ?></td>
		</tr>
		<tr>
			<th>Parent Theme</th>
			<td><?php echo get_bloginfo( 'template_directory' ); ?></td>
		</tr>
		<tr>
			<th>User Roles</th>
			<td>
			<?php
			global $wp_roles;
			foreach ( $wp_roles->roles as $role => $capabilities ) {
				echo '<span class="wpmr_bricks">' . $role . '</span>';}
			?>
			</td>
		</tr>
		<tr>
			<th>Must-Use Plugins</th>
			<td>
			<?php
			$mu = get_mu_plugins();
			foreach ( $mu as $key => $value ) {
				echo '<span class="wpmr_bricks">' . $key . '</span>';}
			?>
			</td>
		</tr>
		<tr>
			<th>Drop-ins</th>
			<td>
			<?php
			$dropins = get_dropins();
			foreach ( $dropins as $key => $value ) {
				echo '<span class="wpmr_bricks">' . $key . '</span>';}
			?>
			</td>
		</tr>
		
		<tr>
			<th>PHP:</th>
			<td><?php echo phpversion(); ?></td>
		</tr>
		<tr>
			<th>Server:</th>
			<td><?php echo $_SERVER['SERVER_SOFTWARE']; ?></td>
		</tr>
		<tr>
			<th>Total Files</th>
			<td><?php echo count( $this->get_all_files() ); ?></td>
		</tr>
		<tr>
			<th>Definitions:</th>
			<td><?php echo $this->get_setting( 'signatures' )['v']; ?></td>
		</tr>
		<tr>
			<th>Last Updated:</th>
			<td id="last_updated">
				<?php echo $this->get_last_updated_ago(); ?>
			</td>
		</tr>
		
		
	    </table>
		<?php
	}

	function meta_box_support() {
		?>
		<div class="scan-support">
			<p><img src="<?php echo $this->url; ?>assets/shiv8288-72.jpg"></p>
			<p>Hi, I’m Shiv — the author of malCure Malware Removal &amp; Firewall. I work in defense as an IT information-security analyst with a
				career spanning over 18+ years.</p>
			<p><strong>WP-Malware-Removal.Com serves 40,000+ definition updates everyday.</strong> Your donations support further
				development of this plugin. <strong><a target="_blank"
						href="https://www.converticacommerce.com?item_name=Donation%20for%20WP%20Malware%20Removal&cmd=_donations&currency_code=USD&lc=US&business=shivanand@converticacommerce.com">Please
						consider a donation.</a></strong></p>
			<p>If you find a bug in the plugin, do not hesitate to contact me.</p>
			<p><strong><a href="https://wp-malware-removal.com/?p=300&utm_source=wpmr" target="_blank"
						class="button-primary">File support request</a></strong></p>
			<p><strong><a href="https://twitter.com/shivtwin" target="_blank" class="button-secondary">Twitter</a></strong></p>
		</div>
		<?php
	}

	function save_gsc_profile() {
		if ( isset( $_REQUEST['wpmr-action'] ) && $_REQUEST['wpmr-action'] == 'oauth' ) {
			wp_verify_nonce( $_REQUEST['origin_nonce'], 'wpmr_gscapi' );
			if ( current_user_can( 'activate_plugins' )
			&& isset( $_REQUEST['success'] ) && $_REQUEST['success']
			) {
				$wpmr_reg = $this->get_setting( 'user' );
				if ( $wpmr_reg ) {
					$wpmr_reg['gsc'] = true;
					$this->update_setting( 'user', $wpmr_reg );
				}
			} else {
			}
			wp_redirect( esc_url( get_admin_url( null, 'options-general.php?page=wpmr' ) ), 302 );
			exit;
		}

		if ( isset( $_REQUEST['wpmr-action'] ) && $_REQUEST['wpmr-action'] == 'revoke' && isset( $_REQUEST['success'] ) && $_REQUEST['success'] == '1' ) {
			$wpmr_reg = $this->get_setting( 'user' );
			if ( $wpmr_reg && ! empty( $wpmr_reg['gsc'] ) ) {
				unset( $wpmr_reg['gsc'] );
				$this->update_setting( 'user', $wpmr_reg );
			}
		}
	}

	function set_plugin_data() {
		if ( is_admin() ) {
			$this->plugin_data = get_plugin_data( WPMR_PLUGIN, false, false );
		}
	}

	function admin_style() {
		?>
		<style type="text/css">
		#toplevel_page_wpmr .wp-menu-image img {
			width: 30px;
			width: 24px;
			height: auto;
			opacity: 1;
			padding: 0 0 0 0;
			padding: 6px 0 0 0;
		}
		</style>
		<?php
	}

	function wpmr_register() {
		check_ajax_referer( 'wpmr_register', 'wpmr_register_nonce' );

		global $wp_version;

		if ( empty( $_REQUEST['user'] ) || empty( $_REQUEST['user']['email'] ) || empty( $_REQUEST['user']['fn'] ) || empty( $_REQUEST['user']['ln'] ) ) {
			wp_send_json( array( 'error' => 'Please fill all details' ) );
		}
		if ( ! filter_var( $_REQUEST['user']['email'], FILTER_VALIDATE_EMAIL ) ) {
			wp_send_json( array( 'error' => 'Invalid email' ) );
		}

		$args = array(
			'user' => $_REQUEST['user'],
			'diag' => array(
				'site_url'       => trailingslashit( site_url() ),
				'php'            => phpversion(),
				'web_server'     => $_SERVER['SERVER_SOFTWARE'],
				'wp'             => $wp_version,
				'plugin_version' => $this->plugin_data['Version'],
				'cachebust'      => microtime(),
			),
		);

		$args = $this->encode( $args );
		$url  = add_query_arg(
			'wpmr_action',
			'wpmr_register',
			add_query_arg(
				'p',
				'495',
				add_query_arg( 'reg_details', $args, WPMR_SERVER )
			)
		);

		$response = wp_safe_remote_request(
			$url,
			array(
				'blocking' => true,
			)
		);
		if ( is_wp_error( $response ) ) {
			wp_send_json( array( 'error' => $response->get_error_message() ) );
		}

		$response = wp_remote_retrieve_body( $response );

		if ( empty( $response ) || is_null( $response ) ) {
			wp_send_json( array( 'error' => 'No response. Registration Failed.' ) );
		}

		$data = json_decode( $response, true );

		if ( ! isset( $data['error'] ) ) {
			$this->update_setting( 'user', $data );
		}
		wp_send_json( $data );

	}

	function get_diag_data() {
		// diag data for server side validation, load balancing, spam protection
		global $wp_version;
		$current_user = wp_get_current_user();
		$data         = array(
			'php'            => phpversion(),
			'web_server'     => $_SERVER['SERVER_SOFTWARE'],
			'wp'             => $wp_version,
			'key'            => md5( site_url() ),
			'site_url'       => trailingslashit( site_url() ),
			'signatures'     => $this->get_setting( 'signatures' )['v'],
			'plugin'         => $this->plugin_data['Version'],
			'return_url'     => esc_url( get_admin_url( null, 'options-general.php?page=wpmr' ) ),
			'origin_ajaxurl' => admin_url( 'admin-ajax.php' ),
			'origin_nonce'   => wp_create_nonce( 'wpmr_gscapi' ),
			'user_firstname' => $current_user->user_firstname,
			'user_lastname'  => $current_user->user_lastname,
			'user_email'     => $current_user->user_email,
		);
		return $data;
	}

	function get_definitions_update_url() {
		$url               = WPMR_SERVER;
		$args              = array(
			'cachebust'   => time(),
			'wpmr_action' => 'update-definitions',
		);
			$compatibility = $this->plugin_data;
			$state         = $this->get_setting( 'user' );
		if ( $state ) {
			$state = array_merge( $state, $compatibility );
		} else {
			$state = $compatibility;
		}
			$args['state'] = $this->encode( $state );
		return trailingslashit( $url ) . '?' . urldecode( http_build_query( $args ) );
	}

	function check_definitions() {

		$response    = wp_safe_remote_request( $this->get_definitions_check_url() );
		$headers     = wp_remote_retrieve_headers( $response );
		$status_code = wp_remote_retrieve_response_code( $response );
		if ( 200 != $status_code ) {
			return;
		}
		if ( is_wp_error( $response ) ) {
			return;
		}
		$body    = wp_remote_retrieve_body( $response );
		$version = json_decode( $body, true );
		if ( $version['success'] != true ) {
			return;
		}
		if ( ! empty( $version['success'] ) && $version['success'] == true ) {
			$version = $version['data'];
			$time    = date( 'U' );
			$this->update_setting( 'update-version', $version );
			return true;
		}
	}

	function get_definitions_check_url() {
		$url               = WPMR_SERVER;
		$args              = array(
			'cachebust'   => time(),
			'wpmr_action' => 'check-definitions',
		);
			$compatibility = $this->plugin_data;
			$state         = $this->get_setting( 'user' );
		if ( $state ) {
			$state = array_merge( $state, $compatibility );
		} else {
			$state = $compatibility;
		}
			$args['state'] = $this->encode( $state );
		return trailingslashit( $url ) . '?' . urldecode( http_build_query( $args ) );
	}

	function update_definitions( $force = false ) {

		check_ajax_referer( 'wpmr_update_sigs', 'wpmr_update_nonce' );

		$response    = wp_safe_remote_request( $this->get_definitions_update_url() );
		$headers     = wp_remote_retrieve_headers( $response );
		$status_code = wp_remote_retrieve_response_code( $response );
		if ( 200 != $status_code ) {
			return;
		}
		if ( is_wp_error( $response ) ) {
			return;
		}
		$body        = wp_remote_retrieve_body( $response );
		$definitions = json_decode( $body, true );
		if ( $definitions['success'] != true ) {
			return;
		}
		if ( ! empty( $definitions['success'] ) && $definitions['success'] == true ) {
			$definitions = $definitions['data'];
			$this->update_setting( 'signatures', $definitions );
			$time = date( 'U' );
			$this->update_setting( 'sig_time', $time );
			return true;
		}
	}

	function get_definitions() {
		$definitions = $this->get_setting( 'signatures' );
		if ( ! $definitions ) {
				$definitions = file_get_contents( trailingslashit( __DIR__ ) . 'wpmr.json' );
				$definitions = json_decode( $definitions, true );
				$this->update_setting( 'signatures', $definitions );
				$this->update_setting( 'sig_time', 0 );
				unset( $definitions['v'] );
				return $definitions;
		} else {
			unset( $definitions['v'] );
			return $definitions;
		}
	}

	function add_admin_scripts() {
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'common' );
		wp_enqueue_script( 'wp-lists' );
		wp_enqueue_script( 'postbox' );
	}

	/* Add links below the plugin name on the plugins page */
	function plugin_action_links( $links ) {
		$links[] = '<a href="' . esc_url( get_admin_url( null, 'options-general.php?page=wpmr' ) ) . '">Run Site Scan</a>';
		$links[] = '<a target="_blank" href="https://www.converticacommerce.com?item_name=Donation%20for%20WP%20Malware%20Removal&cmd=_donations&currency_code=USD&lc=US&business=shivanand@converticacommerce.com"><strong style="display:inline">Donate</strong></a>';
		return $links;
	}

	function plugin_meta_links( $links, $file ) {
		if ( $file !== plugin_basename( WPMR_PLUGIN ) ) {
			return $links;
		}
		$links[] = '<strong><a target="_blank" href="https://wp-malware-removal.com/?p=300&utm_source=wpmr" title="Malware Cleanup Service">Malware Support</a></strong>';
		$links[] = '<strong><a target="_blank" href="https://wp-malware-removal.com/?utm_source=wpmr" title="Website of this plugin">Plugin Homepage</a></strong>';
		$links[] = '<strong><a target="_blank" href="https://wordpress.org/support/plugin/wp-malware-removal/reviews/" title="Rate malCure Malware Removal &amp; Firewall">Rate the plugin ★★★★★</a></strong>';
		$links[] = '<strong><a target="_blank" href="https://www.converticacommerce.com?item_name=Donation%20for%20WP%20Malware%20Removal&cmd=_xclick&currency_code=USD&business=shivanand@converticacommerce.com"><strong style="display:inline">Donate</strong></a></strong>';
		return $links;
	}

	function plugin_styles() {
		$screen = get_current_screen();
		if ( $screen->id == 'toplevel_page_wpmr' || $screen->id == 'malware-removal_page_wpmr-tools' ) {
			wp_enqueue_style( 'wpmr-stylesheet', WPMR_PLUGIN_DIR_URL . 'assets/admin-styles.css' );
		}
	}

	function llog( $str, $echo = true ) {
		if ( $echo ) {
			echo '<pre>';
			print_r( $str );
			echo '</pre>';
		} else {
			return print_r( $str, 1 );
		}
	}

	function settings_menu() {
		$hook_suffix = add_menu_page(
			'malCure Scanner',
			'malCure Scanner',
			'manage_options',
			'wpmr',
			array( $this, 'scanner_page' ),
            $this->url . 'assets/icon.svg',
            79
		);
		add_submenu_page( 'wpmr', 'Run Scan', 'Run Scan', 'manage_options', 'wpmr', array( $this, 'scanner_page' ) );
		add_submenu_page( 'wpmr', 'Firewall', 'Firewall', 'manage_options', 'wpmr_firewall', array( $this, 'settings_page' ) );
	}

	function get_last_updated_ago() {
		$updated = $this->get_setting( 'sig_time' );
		if ( ! $updated ) {
			return 'Never';
		} else {
				return human_time_diff( date( 'U', $updated ), date( 'U' ) ) . ' ago';
		}
	}

	function get_definition_count() {
		$defs  = $this->get_setting( 'signatures' );
		$count = 0;
		while ( count( $defs['definitions'] ) ) {
			// $this->llog(array_shift($defs['definitions']));
			$count += count( array_shift( $defs['definitions'] ) );
		}
		// $this->llog( $count );
		return $count;
	}

	function scanner_page() {
		$this->get_checksums();
		$this->get_definitions();
		$this->check_definitions();
		?>
		<div class="wrap">
			<h1>malCure Malware Removal &amp; Firewall</h1>
			<div class="container-wrap">
				<div class="engine_stats">
					<span id="icon"></span>
					<table id="engine_stats">
						<tr>
							<th>Checksums:</th>
							<td><span class="checksum_count"><?php echo count( $this->get_checksums() ); ?></span></td>
						</tr>
						<tr>
							<th>Signatures:</th>
							<td><span class="sig_count"> <?php echo $this->get_definition_count(); ?></span></td>
						</tr>
						<tr>
							<th>Last Updated:</th>
							<td><span class="sig_date"><?php echo $this->get_last_updated_ago(); ?></span></td>
						</tr>
						<tr>
							<th>Total Files:</th>
							<td><span class="total_files"><?php echo count( $this->get_all_files() ); ?></span></td>
						</tr>
						<tr>
							<th>Files Excluded:</th>
							<td><span class="files_excluded"><?php echo ( count( $this->get_all_files() ) - $this->bootstrap()['count'] ); ?></span></td>
						</tr>
						<tr>
							<th>Files to scan:</th>
							<td><span id="files_to_scan"><?php echo $this->bootstrap()['count']; ?></span></td>
						</tr>
						<tr>
							<th>Files remaining:</th>
							<td><span id="files_remaining"><?php echo $this->bootstrap( )['count']; ?></span></td>
						</tr>
						<tr>
							<th>Time Elapsed:</th>
							<td><span id="time_elapsed">Not Initialised</span></td>
						</tr>
						<tr>
							<th>Time Remaining:</th>
							<td><span id="time_remaining">Not Initialised</span></td>
						</tr>
						<tr>
							<th>Achieved Speed:</th>
							<td><span id="scan_speed">Duck</span></td>
						</tr>
						<tr>
							<th>Status:</th>
							<td><span class="engine_status">Ready</span></td>
						</tr>
					</table>
				</div>
				<div class="container">
					<div class="gauge-a"></div>
					<div class="gauge-c"></div>
					<div class="gauge-data">
						<h1 id="percent"></h1>
					</div>
				</div>
				<div id="ux">
					<div id="wpmr-fle-scroll-wrap"><span id="file-scroll"></span></div>
					<div id="wpmr-scan-conrol-wrap"><input type="submit" value="Start Scan" id="scan-control" data-state="0"
							class="button-primary" /></div>
					
					<div id="wpmr-batchsize-wrap" title="Your webhost may block too many requests. Be careful.">
                        <label for="wpmr-batchsize">No. of files to scan per request</label>
                        <input type="range" id="wpmr-batchsize" value="1" name="points" min="1" max="100" />
					</div>
					<div id="wpmr-scan-instructions-wrap" title="Your webhost may block too many requests. Be careful."><span
							id="scan-instructions">Scanning 1 File per req.</span></div>
				</div>
				<div id="lcd"></div>
				<div class="clear"></div>
			</div>

			<div id="poststuff">
				<div class="metabox-holder columns-2" id="post-body">
					<div class="postbox-container" id="post-body-content">
						<?php do_meta_boxes( 'toplevel_page_wpmr', 'main', null ); ?>
					</div>
					<!-- #postbox-container -->
					<div id="postbox-container-1" class="postbox-container">
						<?php
								do_meta_boxes( 'toplevel_page_wpmr', 'side', null );
						?>
					</div>
				</div>
			</div>
		</div>
		<script type="text/javascript">
		//<![CDATA[
		jQuery(document).ready(function($) {
			$('#wpmr-god').change(function() {
				if ($(this).prop('checked')) {
					$('#wpmr-batchsize-wrap').removeClass('transparent');
				} else {
					$('#wpmr-batchsize-wrap').addClass('transparent');
				}
			});
			$('#wpmr-batchsize').change(function() {
				val = $('#wpmr-batchsize').val();
				if (val > 1) {
					html = 'Scanning ' +val + ' Files per req.';
				} else {
					html = 'Scanning' + val + ' File per req.';
				}
				$('#scan-instructions').html(html);
			});
			// close postboxes that should be closed
			$('.if-js-closed').removeClass('if-js-closed').addClass('closed');
			// postboxes setup
			postboxes.add_postbox_toggles('toplevel_page_wpmr');
		});
		//]]>
		</script>
		<?php
	}

	function wpmr_inspect_file() {
		check_ajax_referer( 'wpmr_inspect_file', 'wpmr_inspect_nonce' );
		wp_send_json( $this->file_checks( $_REQUEST['file'] ) );
	}

	function file_checks( $file ) {
		if ( is_file( $file ) && is_readable( $file ) && ( ! filesize( $file ) <= 0 ) && filesize( $file ) < 10800000 ) { // file checks passed
			$content = file_get_contents( $file );
			if ( $content !== false ) { // file_get_contents succeeded
				$content = htmlspecialchars( $content, ENT_SUBSTITUTE );
				if ( ! $content ) { // non-printable chars
					wp_send_json(
						array(
							'status' => 'error',
							'error'  => 'File contains non-printable characters.',
						)
					);
				} // non-printable chars
				wp_send_json(
					array(
						'status'  => 'success',
						'error'   => '',
						'content' => $content,
					)
				);
			} // file_get_contents succeeded
			else { // file_get_contents failed
				wp_send_json(
					array(
						'status' => 'error',
						'error'  => 'Error getting file contents.',
					)
				);
			} // file_get_contents failed
		} // file checks passed
		else { // file checks failed
			wp_send_json(
				array(
					'status' => 'error',
					'error'  => 'Empty or inaccessible or too large a file',
				)
			);
		} // file checks failed
	}

	/* Ajax request handler for triggering scan */
	function wpmr_init_scan() {
		check_ajax_referer( 'wpmr_init_scan', 'wpmr_init_nonce' );
		wp_send_json( $this->bootstrap( $_REQUEST ) );
	}

	function db_scan() {
		global $wpdb;
		$time = microtime( true );
		// $this->llog($this->get_definitions_update_url());
		// echo 'initial time:' . $time . '<br />';
		$scan_sqls   = array(
			'post'      => "SELECT ID AS id, post_content AS content FROM $wpdb->posts where post_content LIKE '%s'",
			'post_meta' => "SELECT post_id AS id, meta_value AS content FROM $wpdb->postmeta where meta_value LIKE '%s'",
			'option'    => "SELECT option_id AS id, option_value AS content FROM $wpdb->options WHERE option_value LIKE '%s'",
		);
		$definitions = $this->get_definitions()['definitions']['db'];
		foreach ( $definitions as $ver => $details ) {
			foreach ( $scan_sqls as $key => $sql ) {
				$results = $wpdb->get_results( $wpdb->prepare( $sql, $this->decode( $details['query'] ) ), ARRAY_A );
				foreach ( $results as $result ) {
					$content  = $result['content'];
					$id       = $result['id'];
					$matches  = preg_match( $this->decode( $details['signature'] ), $content );
					$pcre_err = preg_last_error();
					if ( $pcre_err != 0 ) {
						continue;
					}
					if ( $matches >= 1 ) {
						return '<span class="threat ' . $details['severity'] . '">Found database infection in ' . ucwords( $key ) . " id $id. Threat Level: " . $details['severity'] . '</span>';
					}
				}
			}
		}
	}

	function bootstrap( $request = array() ) {
        
        if( ! empty( $request['skipdirs'] ) ) {
            $skipdirs = array_map( 'trim', explode( ',', $request['skipdirs'] ) );
            $GLOBALS["WPMR"]["skipdirs"] = $skipdirs;
        }
        else {
            $GLOBALS["WPMR"]["skipdirs"] = array();
        }
		$files = $this->get_all_files();
		if ( is_array( $files ) ) {
            $suspicious = ( empty( $request['suspicious']) || $request['suspicious'] == "true" ) ? true: false;
            if( ! $suspicious ) {
                $files = array_filter(
                    $files,
                    function( $value, $key ) {
                        return ! in_array( $this->get_fileext( $value ), $this->get_excluded() );
                    },
                    ARRAY_FILTER_USE_BOTH
                );
            }
		}
		return array(
			'files'     => $files,
			'timestamp' => empty($request['timestamp'])?time():$request['timestamp'],
			'count'     => count( $files ),
			'db_scan'   => $this->db_scan(),
		);
	}
    
	function get_all_files( $path = false ) {
		if ( ! $path ) {
			$path = untrailingslashit( get_home_path() );
        }
        $exempted = ! empty( $GLOBALS["WPMR"]["skipdirs"] ) ? in_array( basename( $path ), $GLOBALS["WPMR"]["skipdirs"] ) : false;
		if ( is_dir( $path ) && ! $exempted ) {
			$children = @scandir( $path );
			if ( is_array( $children ) ) {
				$children = array_diff( $children, array( '..', '.' ) );
				$dirs     = array();
				$files    = array();
				foreach ( $children  as $child ) {
					$target = trailingslashit( $path ) . $child;
					if ( is_dir( $target ) ) {
						$elements = $this->get_all_files( $target );
						if ( $elements ) { // check for read/write errors
							foreach ( $elements as $element ) {
								$files[] = $element;
							}
						}
					}
					if ( is_file( $target ) ) {
						$files[] = $target;
					}
				}
				return $files;
			}
		}
    }
    
	function wpmr_scan_files() {
		$files = $_REQUEST['files'];
        $tests = array();
        $registered = $this->is_registered();
		foreach ( $files as $file ) {
			if ( $this->fails_checksum( $file ) ) { // if file fails checksum
				$probable = $this->wpmr_scan_file_threats( $file, $_REQUEST['suspicious'] == "true" );
				if ( $probable ) {
					$tests[ $file ] = $probable;
                }
                else {
                    if( ( $this->fails_checksum( $file ) == 1 ) && ( ! $registered ) ) {
                        $tests[ $file ] = '<span class="threat suspicious">mismatch</span>';
                    }
                }
            }
            
		}
		wp_send_json(
			array(
				'report' => $tests,
				'memory' => ( memory_get_peak_usage( true ) / 1024 / 1024 ),
			)
		);
	}

    function fails_checksum( $local_file ) {
		$checksums    = $this->get_checksums();
		$install_path = get_home_path();
		$file         = array();
        $match_path   = str_replace( $install_path, '', $local_file );
		if ( array_key_exists( $match_path, $checksums ) ) {
			//if ( empty( $checksums[ $match_path ] ) ) {
			//	return;
			//}
			if ( is_array( $checksums[ $match_path ] ) ) { // plugin readmes can have multiple md5 hashes since a readme.txt can be updated on svn without bumping the plugin version
				if ( ! in_array( md5_file( $local_file ), $checksums[ $match_path ] ) ) {
					return 1;
				} else {
					return;
				}
			} else {
				if ( $checksums[ $match_path ] != md5_file( $local_file ) ) {
					return 1;
				} else {
					return;
				}
			}
		} else {
			return 2; // we found a file that's not a part of WordPress
		}
    }
    
	function wpmr_scan_file_threats( $file, $suspicious ) {
		if ( @filesize( $file ) > 10800000 ) {
			return;         }
		$ext = $this->get_fileext( $file );
		if ( ! $suspicious && in_array( $ext, $this->get_excluded() ) ) {
			return; // 'Excluded';
		}
		$tests = array();
		if ( ! is_readable( $file ) ) {
			return '<span class="threat skipped" title="WordPress Malware Removal could not access and read this file for scanning">Error Reading File</span>';
		}
		if ( ! is_file( $file ) || ! ( $filesize = filesize( $file ) ) || ! ( $GLOBALS['WPMR']['tmp']['file_contents'] = @file_get_contents( $file ) ) ) {
			return; // '<span class="skipped" title="">Something Fishy with file'.$file.': filesize:'.filesize($file).':</span>';
		}
		if ( $GLOBALS['WPMR']['tmp']['file_contents'] === false ) {
			return '<span class="threat skipped" title="WordPress Malware Removal could not access and read this file for scanning">Error Reading File</span>';
		}
		if ( empty( $GLOBALS['WPMR']['tmp']['file_contents'] ) ) {
			return;// 'Empty' ; // why care?
		}
		$definitions = $this->get_definitions()['definitions']['files'];
		foreach ( $definitions as $definition => $signature ) {
			// $i++;
			if ( $signature['class'] == 'htaccess' && $ext != 'htaccess' ) {
				continue;
			}
			if ( $signature['severity'] == 'suspicious' && ! $suspicious) {
				continue;
			}
			$matches  = preg_match( $this->decode( $signature['signature'] ), $GLOBALS['WPMR']['tmp']['file_contents'] );
			$pcre_err = preg_last_error();
			if ( $pcre_err != 0 ) {
				continue;
			}
			if ( $matches >= 1 ) {
				return '<span class="threat ' . $signature['severity'] . '">' . $signature['severity'] . '</span>';
			}
		}
	}

	function get_excluded() {
		return apply_filters(
			'wpmr_excluded_ext',
			array(
				'7z',
				'bmp',
				'bz2',
				'css',
				'doc',
				'docx',
				'exe',
				'fla',
				'flv',
				'gif',
				'gz',
				'jpeg',
				'jpg',
				'less',
				'mo',
				'mov',
				'mp3',
				'pdf',
				'png',
				'po',
				'pot',
				'psd',
				'rar',
				'scss',
				'so',
				'svg',
				'tar',
				'tgz',
				'tif',
				'tiff',
				'ttf',
				'txt',
				'z',
				'zip',
			)
		);
	}

	function get_fileext( $filename ) {
		$nameparts = explode( '.', ".$filename" );
		return strtolower( $nameparts[ ( count( $nameparts ) - 1 ) ] );
	}

	function reset_flog() {
		$date = date( 'Ymd-G:i:s' ); // 20171231-23:59:59
		$file = $this->dir . 'log.log';
		file_put_contents( $file, '', LOCK_EX );
	}

	function flog( $str ) {
		$date = date( 'Ymd-G:i:s' ); // 20171231-23:59:59
		$date = $date . '-' . microtime( true );
		$file = $this->dir . 'log.log';
		file_put_contents( $file, PHP_EOL . $date, FILE_APPEND | LOCK_EX );
		usleep( 1000 );
		$str = print_r( $str, TRUE );
		file_put_contents( $file, PHP_EOL . $str, FILE_APPEND | LOCK_EX );
		usleep( 1000 );
	}

	function delete_checksums() {
		delete_transient( 'WPMR_checksums' );
	}

	function get_checksums( $cached = true ) {
		$checksums = $cached ? get_transient( 'WPMR_checksums' ) : false;
		if ( ! $checksums ) {
			global $wp_version;
			$checksums        = get_core_checksums( $wp_version, get_locale() );
			$plugin_checksums = $this->get_plugin_checksums();
			if ( $plugin_checksums ) {
				$checksums = array_merge( $checksums, $plugin_checksums );
			}
			if ( $checksums ) {
				set_transient( 'WPMR_checksums', $checksums, 6 * HOUR_IN_SECONDS );
				return $checksums;
			}
			return;
		} else {
			return $checksums;
		}
	}

	function get_theme_checksums() {

		$all_themes   = wp_get_themes();
		$install_path = get_home_path();
		$this->llog( $install_path );

		$theme_checksums = array();
		$theme_root      = get_theme_root();
		foreach ( $all_themes as $key => $value ) {
			$this->llog( $key );

			$theme_file = trailingslashit( $theme_root ) . $key;
			$theme_file = str_replace( $install_path, '', $theme_file );
			$this->llog( 'FILE:' . $theme_file );
			$checksum_url = 'https://downloads.wordpress.org/theme/' . $key . '/' . $value['Version'] . '.json';
			$this->llog( $checksum_url );
		}
		$this->llog( $theme_checksums );
	}

	function get_plugin_checksums() {
		$all_plugins      = get_plugins();
		$install_path     = get_home_path();
		$plugin_checksums = array();
		foreach ( $all_plugins as $key => $value ) {
			if ( false !== strpos( $key, '/' ) ) { // plugin has to be inside a directory. currently drop in plugins are not supported
				$plugin_file  = trailingslashit( dirname( $this->dir ) ) . $key;
				$plugin_file  = str_replace( $install_path, '', $plugin_file );
				$checksum_url = 'https://downloads.wordpress.org/plugin-checksums/' . dirname( $key ) . '/' . $value['Version'] . '.json';
				$checksum     = wp_safe_remote_get( $checksum_url );
				if ( is_wp_error( $checksum ) ) {
					continue;
				}
				if ( '200' != wp_remote_retrieve_response_code( $checksum ) ) {
					continue;
				}
				$checksum = wp_remote_retrieve_body( $checksum );
				$checksum = json_decode( $checksum, true );
				if ( ! empty( $checksum['files'] ) ) {
					$checksum = $checksum['files'];
					foreach ( $checksum as $file => $checksums ) {
						$plugin_checksums[ trailingslashit( dirname( $plugin_file ) ) . $file ] = $checksums['md5'];
					}
				}
			} else {
			}
		}
		return $plugin_checksums;
	}

	function read_error( $path ) {
		if ( ! file_exists( $path ) ) {
			return 'are you sure this file exists?: ' . $path;
		}
		if ( ! is_readable( $path ) ) {
			return 'are you sure this file is readable?:' . $path;
		}
		return ( is_array( $error ) && isset( $error['message'] ) ? preg_replace( '/[\r\n]/', ' ', print_r( $error['message'], 1 ) ) : 'readable?' );
	}

	function plugin_update_message( $data, $response ) {
		$changelog = 'https://plugins.trac.wordpress.org/browser/' . basename( $this->dir ) . '/trunk/readme.txt?format=txt&cachebust=' . time(); // should translate into https://plugins.trac.wordpress.org/browser/wp-real-time-social-proof/trunk/readme.txt?format=txt since repo doesn't allow changing slugs
		$res       = wp_safe_remote_get( $changelog );
		if ( is_wp_error( $res ) ) {
			return;
		}
		$res    = wp_remote_retrieve_body( $res );
		$regexp = '~==\s*Changelog\s*==\s*=\s*[0-9.]+\s*=(.*)(=\s*' . preg_quote( $this->plugin_data['Version'] ) . '\s*=|$)~Uis';// $res  = stristr( $res, '== Changelog ==', true );
		if ( ! preg_match( $regexp, $res, $matches ) ) {
			return;
		}
		$changelog = (array) preg_split( '~[\r\n]+~', trim( $matches[1] ) );
		// $ul = false;
		$upgrade_notice = '';
		foreach ( $changelog as $index => $line ) {
			if ( preg_match( '~^\s*\*\s*~', $line ) ) {
				$line            = preg_replace( '~^\s*\*\s*~', '', htmlspecialchars( $line ) );
				$upgrade_notice .= '<span style="font-weight:bold;">&#x2605;</span> ' . $line . '<br />';
			} else {
			}
		}
		$upgrade_notice = '<strong>Upgrading is a must to ensure that this plugin works with the latest signatures.</strong><br />' . $upgrade_notice;
		echo '<br /><br /><span style="display:block; border: 1px solid hsl(200, 100%, 80%); padding: 1em; background: hsl(200, 100%, 90%); line-height:2">' . $upgrade_notice . '</span>';
	}

	/* JS routine to handle user-events and reporting */
	function scripts() {
        $screen = get_current_screen();
		if ( $screen->id == 'toplevel_page_wpmr' ) {
		?>
		<script type="text/javascript">
        registered = <?php echo $this->is_registered() ? 1 : 0; ?>;
        jQuery(document).ready(function($) { //wrapper
            //$('#wpmr-inspect-box').hide();
            $('#wpmr-results-box').addClass('closed');
            $('#wpmr-inspect-box').addClass('closed');
            //$('#wpmr-debug-box').addClass('closed');
            //$('#wpmr-support-box').addClass('closed');
            $("#wpmr-update").click(function(e) { //event
                e.preventDefault();
                wpmr_update = {
                    wpmr_update_nonce: '<?php echo wp_create_nonce( 'wpmr_update_sigs' ); ?>',
                    action: "wpmr_update_sigs",
                    cachebust: Date.now(),
                };
                $.ajax({
                    url: ajaxurl,
                    method: 'POST',
                    data: wpmr_update,
                    //timeout: 1,
                    complete: function(jqXHR, textStatus) {
                        //console.dir(jqXHR);
                        if (textStatus == 'success' || textStatus == 'notmodified') {
                            last_updated = new Date();
                            $('#last_updated').html(last_updated);
                            location.reload(true);
                        }
                    },
                    success: function(response) {

                    } // initialize
                }); // ajax post
            });
            $('#wpmr-register-cancel').click(function(e){
                $('#wpmr-updates-box').removeClass('prompt-register');
            });
            $("#scan-control").click(function(e) { //event
                e.preventDefault();
                if( ! registered ) {
                    msgnodef = window.confirm("A definition update is required to detect the latest malware.\n        Click OK to return and update the definitions (recommended).\n        Click Cancel to continue scanning without definitions (not recommended).");
                    //console.dir( msgnodef );
                    if(msgnodef) {
                        return wpmr_prompt_register();
                        //return;
                    }
                }
                window.onbeforeunload = function() {
                    return true;
                };
                record = new Date().getTime();
                $('.container .gauge-c').css('transform', 'rotate( 0turn)');
                $('#file-results').html('');
                $('#percent').html('');
                $('#lcd').html('');
                $('.engine_status').toggleClass('blink');
                $('#icon').toggleClass('running');
                $('.engine_status').html('counting files…');
                total_files = 0;
                $("#scan-control").attr('disabled', 'disabled');
                $("#wpmr-batchsize").attr('disabled', 'disabled');
                $("#wpmr-god").attr('disabled', 'disabled');
                wpmr_init_scan = {
                    wpmr_init_nonce: '<?php echo wp_create_nonce( 'wpmr_init_scan' ); ?>',
                    action: "wpmr_init_scan",
                    timestamp: record,
                    cachebust: Date.now(),
                    skipdirs: $('#skipdirs').val() ? $('#skipdirs').val(): '',
                    suspicious: document.getElementById('show_suspicious').checked,
                };
                //console.dir(wpmr_init_scan);
                $.ajax({
                    url: ajaxurl,
                    method: 'POST',
                    data: wpmr_init_scan,
                    complete: function(jqXHR, textStatus) {},
                    success: function(response) {
                        //return;
                        //console.dir(response);
                        
                        db_result = response.db_scan;
                        found = 0;
                        if (db_result) {
                            $('#db-results').html(db_result);
                            found = 1;
                        } else {
                            $('#db-results').html(
                                '<p>All Well. Nothing found in the database 🙂</p>');
                            found = 0;
                        }
                        files = response.files;
                        files = Object.values(files);
                        $('.engine_status').html('initialized…');
                        last = 0;
                        results = [];
                        old_time = Date.now();
                        results.starttime = old_time;
                        results.totalfiles = files.length;
                        $('.files_excluded').html( parseInt( $('.total_files').html() ) - files.length ) ;
                        $('#files_to_scan').html(results.totalfiles);
                        results.memory = 0;
                        results.infectedfiles = {};

                        failed = [];
                        iteration = 0;

                        if (files.length) {
                            $('.engine_status').html('scanning…');
                            sent = Date.now();
                            scan_files();
                            $('#wpmr-results-box').removeClass('closed');
                        }
                        
                        
                        function scan_files() {
                            batchsize = ( iteration == 0) ? $('#wpmr-batchsize').val(): batchsize;
                            $('#wpmr-batchsize').attr('disabled', 'disabled');
                            if (!files.length) {
                                //console.log('no files');
                                return;
                            } 
                            wpmr_scan_files = {
                                action: "wpmr_scan_files",
                                suspicious: document.getElementById('show_suspicious').checked,
                                files: (files.length) ? (files.length > batchsize ? files
                                    .splice(0, batchsize) : files) : false
                            };
                            lastbatch = wpmr_scan_files.files;
                            siteroot = '<?php echo get_home_path(); ?>';
                            $('#file-scroll').html('../' + lastbatch[0].replace(siteroot, ''));
                            
                            $.ajax({
                                url: ajaxurl,
                                method: 'POST',
                                data: wpmr_scan_files,
                                success: function(scan_status) {},
                                complete(jqXHR, textStatus) {
                                    //console.dir(jqXHR);
                                    //console.log('received in ' + (Date.now() - sent)) ;
                                    var scan_status = {};
                                    if (textStatus == "success") {
                                        //console.dir(jqXHR);
                                        scan_status = jqXHR.responseJSON.report;
                                    } else { // ajax failure
                                        console.dir(lastbatch);
                                        Object.entries(lastbatch).forEach(([key,
                                            value
                                        ]) => {
                                            //console.log(key);
                                            if( iteration == 0 ){
                                                failed.push(value);
                                            }
                                            else {
                                                scan_status[value] = '<span class="threat skipped" title="Server returned invalid information while scanning this file. Don\'t worry. You can always rescan.">Invalid Scan Response</span>';
                                            }
                                        }); 
                                    }
                                    new_time = Date.now();
                                    old_time = Date.now();
                                    html = '';   
                                    if (Object.keys(scan_status).length) {
                                        Object.entries(scan_status).forEach(([key,
                                            value
                                        ]) => {
                                            results.infectedfiles[key] = value;
                                        });
                                        found = Object.keys(results.infectedfiles).length;
                                    }
                                    if ( found ) {
                                        html =
                                            '<table id="scan-records"><thead><tr><th>Status</th><th>File</th><th></th></tr></thead><tbody>';
                                        $('#wpmr-what-to-do').show();
                                    }
                                    Object.entries(results.infectedfiles).forEach(([key,
                                        value
                                    ]) => {
                                        html +=
                                            '<tr class="dected"><td class="level">' +
                                            value +
                                            '</td><td class="inspect"><span class="inspect_file button button-secondary button-small" data-file="' +
                                            key +
                                            '">Inspect</span></td><td class="infected-file"><pre class="recorded-file">' +
                                            key + '</pre></td></tr>';
                                    });
                                    if (found) {
                                        html += '</tbody></table>';
                                    } else {
                                        html =
                                            '<p class="blink">All Well. Nothing yet&hellip; 🙂</p>';
                                    }
                                    $('#file-results').html(html);
                                    results.filesremaining = files.length
                                    if (textStatus == "success" && jqXHR.hasOwnProperty(
                                            'responseJSON') && jqXHR.responseJSON
                                        .hasOwnProperty('memory') && jqXHR.responseJSON
                                        .memory > results.memory) {
                                        results.memory = jqXHR.responseJSON.memory;
                                    }
                                    results.scanspeed = (results.totalfiles - results
                                        .filesremaining) / ((Date.now() - results
                                        .starttime) / 1000);
                                    $('#lcd').html(
                                        '<span class="stats"><span class="speed"><span class="digits">' +
                                        (results.scanspeed).toFixed(0) +
                                        '</span><span class="rate">&nbsp;files / sec</span></span><span class="ram">' +
                                        parseFloat(results.memory).toFixed(0) +
                                        'mb ram</span>').fadeIn(2000);
                                    $('#files_remaining').html(results.filesremaining);
                                    results.timeelapsed = (Date.now() - results.starttime);
                                    $('#time_elapsed').html(msToTime(results.timeelapsed));
                                    $('#scan_speed').html((results.scanspeed).toFixed(0) +
                                        ' files / sec.');
                                    results.timeremaining = results.filesremaining / results
                                        .scanspeed;
                                    $('#time_remaining').html(msToTime(results
                                        .timeremaining * 1000));
                                    percent = ((results.totalfiles - results
                                        .filesremaining) / results.totalfiles) * 100;
                                    if(last) {
                                        //console.log('hit last. iteration is:');
                                        //console.log(iteration);
                                        iteration++;
                                        $('#files_remaining').html('0');
                                        $('#icon').toggleClass('running');
                                        $('.engine_status').toggleClass('blink');
                                        $('.engine_status').html('complete');
                                        $('#time_remaining').html('finished');
                                        $('#scan_speed').html('done');
                                        $('#files_to_scan').html('none');
                                        $('#file-scroll').html('');
                                        percent = 100; 
                                        $('html,body').animate({
                                            scrollTop: $('#file-results').offset()
                                                .top
                                        }, 'slow');
                                        if (found) {
                                            $('#wpmr-support-box').removeClass('closed');
                                        } else {
                                            $('#file-results').html(
                                                '<p>All Well. Nothing to do 🙂</p>');
                                        }
                                        $("#scan-control").val('Re-Scan');
                                        $("#scan-control").removeAttr('disabled');
                                        $('#wpmr-batchsize').removeAttr('disabled');
                                        $("#wpmr-god").removeAttr('disabled');
                                        //console.dir('files');
                                        //console.dir(files);
                                        //console.dir('failed');
                                        //console.dir(failed);
                                        if(failed.length && iteration == 1){
                                            files = failed;
                                            last = 0;
                                            failed = [];
                                            batchsize = 1;
                                            $('.engine_status').html('re-scanning…');
                                            //console.log('files.length');
                                            //console.log(files.length);
                                            //console.log('files');
                                            //console.dir(files);
                                            //console.log('rescan required');
                                            //console.log('iteration is'  + iteration);
                                            scan_files();
                                        }
                                        window.onbeforeunload = null;
                                    }
                                    $('#percent').html('<span class="percentage">' +
                                        parseFloat(percent).toFixed(0) +
                                        '%</span><br /><span class="time">' + msToTime(
                                            results.timeelapsed) + '</span>');
                                    $('.container .gauge-c').css('transform', 'rotate( ' + (
                                        .005 * percent) + 'turn)');
                                    if (last != 1) {
                                        if (files.length <= batchsize) {
                                            last = 1;
                                        }
                                        sent = Date.now();
                                        scan_files();
                                    }
                                },
                                error: function(jqXHR, textStatus, errorThrown) {}
                            });
                        }
                    }, // initialize
                }); // ajax post
            }); //click
            $('#file-results').on('click', '.inspect_file', function(event) {
                event.preventDefault();
                file = $(this).attr('data-file');
                if (file) {
                    wpmr_inspect_file = {
                        wpmr_inspect_nonce: '<?php echo wp_create_nonce( 'wpmr_inspect_file' ); ?>',
                        action: "wpmr_inspect_file",
                        file: file
                    };
                    $.ajax({
                        url: ajaxurl,
                        method: 'GET',
                        data: wpmr_inspect_file,
                        complete: function(jqXHR, textStatus) {
                            $('#wpmr-inspect-box').removeClass('closed');
                            //console.log('init wpmr_inspect_file');
                            //console.dir(jqXHR);
                            //console.dir(textStatus);
                            if (textStatus == 'success') {
                                if (jqXHR.hasOwnProperty('responseJSON')) {
                                    if (jqXHR.responseJSON.hasOwnProperty('content') && jqXHR
                                        .responseJSON.content.length) {
                                        $('#inspect_file_path').html(
                                            '<strong>File:</strong> <code>' + file + '</code>');
                                        $('#inspect_file').html(jqXHR.responseJSON.content);
                                    } else {
                                        if (jqXHR.responseJSON.hasOwnProperty('error')) {
                                            $('#inspect_file').html(jqXHR.responseJSON.error);
                                        }
                                    }
                                } else {
                                    $('#inspect_file').html('Invalid response from server');
                                }
                            } else {
                                $('#inspect_file').html('Request failed.');
                            }
                            $('html,body').animate({
                                scrollTop: $('#inspect_file').offset().top
                            }, 'slow');
                        },
                    });
                }
            });

            function wpmr_prompt_register(){
                $('#wpmr-updates-box').addClass('prompt-register');
            }
        
        }); //ready
        
        function msToTime(duration) {
            var milliseconds = parseInt((duration % 1000) / 100),
                seconds = Math.floor((duration / 1000) % 60),
                minutes = Math.floor((duration / (1000 * 60)) % 60),
                hours = Math.floor((duration / (1000 * 60 * 60)) % 24);
            hours = (hours < 10) ? "0" + hours : hours;
            minutes = (minutes < 10) ? "0" + minutes : minutes;
            seconds = (seconds < 10) ? "0" + seconds : seconds;
            if (parseInt(hours)) {
                return hours + ":" + minutes + ":" + seconds;
            } else {
                return minutes + ":" + seconds;
            }
            return hours + ":" + minutes + ":" + seconds + "." + milliseconds;
        }

        function millisToMinutesAndSeconds(millis) {
            var minutes = Math.floor(millis / 60000);
            var seconds = ((millis % 60000) / 1000).toFixed(0);
            return minutes + ":" + (seconds < 10 ? '0' : '') + seconds;
        }
        </script>
		<?php
        }
	}

	function is_registered() {
		return $this->get_setting( 'user' );
	}

	function encode( $str ) {
		return strtr( base64_encode( json_encode( $str ) ), '+/=', '-_,' );
	}

	function decode( $str ) {
		return json_decode( base64_decode( strtr( $str, '-_,', '+/=' ) ), true );
	}

	function get_wp_config_path() {
		$search = array(
			ABSPATH . 'wp-config.php',
			dirname( ABSPATH ) . DIRECTORY_SEPARATOR . 'wp-config.php',
		);

		foreach ( $search as $path ) {
			if ( file_exists( $path ) ) {
				return $path;
			}
		}

		return false;
	}
    
     /* Render the settings page */
     function settings_page(){ ?>
        <div class="wrap">
        <div class="container">
            <form method="post" action="options.php">
            <?php settings_fields( 'wpmr_settings' ); ?>
            <?php do_settings_sections( 'wpmr_firewall' ); ?>
            <?php submit_button(); ?>
            </form>
        </div>
    <?php
    }

    function register_settings(){
        register_setting('wpmr_fw_settings', 'wpmr_fw_settings', array('default' => array( $this,'defaults' ), 'sanitize_callback' => array($this, 'sanitize') ) ) ;
        add_settings_section('wpmr_fw', 'Firewall Settings', array( $this,'firewall_section_ui' ), 'wpmr_firewall');
        //add_settings_field('fw_enabled', '', array($this, 'fw_enabled_ui'), 'wpmr_firewall', 'wpmr_fw');
        add_settings_field('fw_block_path_traversal', '', array($this, 'fw_block_path_traversal_ui'), 'wpmr_firewall', 'wpmr_fw');
        add_settings_field('fw_disable_php_upload', '', array($this, 'fw_disable_php_upload_ui'), 'wpmr_firewall', 'wpmr_fw');
        add_settings_field('fw_disable_restapi_user_listing', '', array($this, 'fw_disable_restapi_user_listing_ui'), 'wpmr_firewall', 'wpmr_fw');
        add_settings_field('fw_disable_user_enumeration', '', array($this, 'fw_disable_user_enumeration_ui'), 'wpmr_firewall', 'wpmr_fw');
    }
    
    function firewall_section_ui(){
        echo 'Here you can configure the firewall';
    }

    function fw_block_path_traversal_ui(){
        $value = $this->get_fw_setting('fw_block_path_traversal');
        ?>
        <label><input type="checkbox" value="1" <?php checked( $value ); ?> name="wpmr_fw_settings[fw_block_path_traversal]" />Block Path Traversal Attack</label>
        <?php
    }
    
    function fw_disable_php_upload_ui(){
        $value = $this->get_fw_setting('fw_disable_php_upload');
        ?>
        <label><input type="checkbox" value="1" <?php checked( $value ); ?> name="wpmr_fw_settings[fw_disable_php_upload]" />Block attack via PHP file upload</label>
        <?php
    }
    
    function fw_disable_restapi_user_listing_ui(){
        $value = $this->get_fw_setting('fw_disable_restapi_user_listing');
        ?>
        <label><input type="checkbox" value="1" <?php checked( $value ); ?> name="wpmr_fw_settings[fw_disable_restapi_user_listing]" />Block listing of users via API</label>
        <?php
    }
    
    function fw_disable_user_enumeration_ui(){
        $value = $this->get_fw_setting('fw_disable_user_enumeration');
        ?>
        <label><input type="checkbox" value="1" <?php checked( $value ); ?> name="wpmr_fw_settings[fw_disable_user_enumeration]" />Block enumeration of users by web-scrapers / bots</label>
        <?php
    }

    function sanitize($values){
        return $values;
    }

	function defaults() {
		$defaults = array(
            //'fw_enabled' => true,
            'fw_block_path_traversal' => true,
            'fw_disable_php_upload' => true,
            'fw_disable_restapi_user_listing' => true,
            'fw_disable_user_enumeration' => true,
        );
		return $defaults;
	}

	function get_fw_setting( $setting ) {
		$defaults = $this->defaults();
		$settings = wp_parse_args( get_option( 'wpmr_settings', $defaults ), $defaults );
		return isset( $settings[ $setting ] ) ? $settings[ $setting ] : false;
	}
    
    function get_setting( $setting ) {
		//$defaults = $this->defaults();
		$settings = wp_parse_args( get_option( 'WPMR', array() ), array() );
		return isset( $settings[ $setting ] ) ? $settings[ $setting ] : false;
	}

	function update_setting( $setting, $value ) {
		$settings = get_option( 'WPMR' );
		if ( ! $settings ) {
			$settings = $this->defaults();
		}
		$settings[ $setting ] = $value;
		return update_option( 'WPMR', $settings );
	}

	function delete_setting( $setting ) {
		$settings = get_option( 'WPMR' );
		if ( ! $settings ) {
			$settings = $this->defaults();
		}
		unset( $settings[ $setting ] );
		update_option( 'WPMR', $settings );
    }
    
    function build_request() {
        if (isset($_REQUEST) && is_array($_REQUEST)) {
            $request = '&';
            foreach ($_REQUEST as $req => $val) {
                $request .= "$req=".(is_array($val)?print_r($val,1):$val)."&";
            }
            return strcasecmp($request,'&') != 0 ? $request : false;
        }
    }

    function build_server() {
        if (isset($_SERVER) && is_array($_SERVER)) {
            $server = '&';
            foreach ($_SERVER as $srv => $val) {
                $server .= "$srv=".(is_array($val)?print_r($val,1):$val)."&";
            }
            return strcasecmp($server,'&') != 0 ? $server : false;
        }
    }

    function build_files() {
        if ( isset( $_FILES ) && is_array( $_FILES ) ) {
            $flies = '&';
            foreach ( $_FILES as $req => $fils ) {
                foreach ( array( 'tmp_name', 'name' ) as $val ) {
                    if ( isset( $fils[ "$val" ] ) ) {
                        $flies .= "$req.$val=" . ( is_array( $fils[ "$val" ] ) ? print_r( $fils[ "$val" ], 1 ) : $fils[ "$val" ] ) . '&';
                    }
                }
            }
            return strcasecmp($flies,'&') != 0 ? $flies : false;
        }
    }
    
    function attack_info(){
        $info = '';
        foreach (array("REMOTE_ADDR", "HTTP_HOST", "REQUEST_URI", "HTTP_REFERER", "HTTP_USER_AGENT") as $var) {
            $info .= ( isset($_SERVER[$var]) ? "&wpmr_SERVER_$var=" . urlencode( $_SERVER[$var] ):'' );
        }
        return $info . '&wpmr_site_url=' . get_site_url() ;
    }

    function waf() {
        if( $this->get_fw_setting('fw_block_path_traversal') ) {
            if ($request = $this->build_request()) {
                $re = '/=[\s\/\.]*(\.\.|etc)\//';
                if( preg_match( $re, $request ) ) {
                    header( 'location: '. WPMR_SERVER . '?wpmr_attack_info=' . $this->encode($this->attack_info()) . '&wpmr_attack_type=path_traversal&time=' . microtime(true) );
                    die();
                }
            }
        }
        if($this->get_fw_setting('fw_disable_php_upload')) {
            if ($files = $this->build_files()) {
                $re = '/name=[^\&]*\.php\&/';
                if( preg_match( $re, $files ) ) {
                    $ref = !empty($_SERVER['HTTP_REFERER'])?$_SERVER['HTTP_REFERER']:'';
                    header( 'location: '. WPMR_SERVER . '?wpmr_attack_info=' . $this->encode($this->attack_info()) . '&wpmr_attack=php_upload&time=' . microtime(true) );
                    die();
                }
            }
        }
        if($this->get_fw_setting('fw_disable_restapi_user_listing')) {
            if($server = $this->build_server()){
                $re = '/wp-json\/wp\/v2\/users(?!\/me)/i';
                if( preg_match( $re, $server ) ) {
                    $ref = !empty($_SERVER['HTTP_REFERER'])?$_SERVER['HTTP_REFERER']:'';
                    header( 'location: '. WPMR_SERVER . '?wpmr_attack_info=' . $this->encode($this->attack_info()) . '&wpmr_attack=restapi_user_listing&time=' . microtime(true) );
                    die();
                }
            }
        }
        if( $this->get_fw_setting('fw_disable_user_enumeration')) {
            if( ( $request = $this->build_request() ) &&  ( $server = $this->build_server() ) ) {
                $re_srv = '/\&REQUEST_URI=(?!\/wp-admin\/)/i';
                $re_req = '/\&author=[0-9]+\&/';
                if( preg_match( $re_req, $request ) && preg_match( $re_srv, $server ) ) {
                    header( 'location: '. WPMR_SERVER . '?wpmr_attack_info=' . $this->encode($this->attack_info()) . '&wpmr_attack=user_enumeration&time=' . microtime(true) );
                    die();
                }
            }
        }
    }

    /*
	function settings_page() {
		$this->check_definitions();

		// phpinfo();
		$this->llog( $_SERVER['REMOTE_ADDR'] );
		$this->llog( $_SERVER['SERVER_PROTOCOL'] );
		$this->llog( $_SERVER['REQUEST_METHOD'] );
		$this->llog( $_SERVER['SCRIPT_FILENAME'] );
		$this->llog( $_SERVER['HTTP_USER_AGENT'] );
		// [%time] %name %client "%method %uri" "%referrer" "%ua" "%forward" "%host"
		// $this->llog($this->get_definitions_update_url());
		// $this->llog($this->get_definitions_check_url());

		// $this->llog( $this->patch_wp_config() );
		// $this->llog( $this->unpatch_wp_config() );
	}
*/
	function get_config_search() {
		return '`\/\/\sBEGIN\sWPMR_WAF.*\/\/\sEND WPMR_WAF\s?+`s';
	}

	function patch_wp_config() {
		$file            = WPMR_PLUGIN_DIR . 'inc/waf.php';
		$config_contents = "<?php\n// BEGIN WPMR_WAF. Security Firewall Installed by https://wordpress.org/plugins/wp-malware-removal/\nif( file_exists( '$file' ) ) {\n\t@include_once '$file';\n}\n// END WPMR_WAF";
		// $this->llog( $config_contents );
		$config_search  = $this->get_config_search();
		$wp_config_path = $this->get_wp_config_path();
		if ( $wp_config_path ) {
			$wp_config   = file_get_contents( $wp_config_path );
			$waf_enabled = preg_match( $config_search, $wp_config );
			if ( ! $waf_enabled ) {
				$wp_config = preg_replace( '`<\?php`s', $config_contents, $wp_config, 1 );
				if ( @copy( $wp_config_path, trailingslashit( dirname( $wp_config_path ) ) . 'wp-config.bak.php' ) ) {// backup in case something goes wrong
					return file_put_contents( $wp_config_path, $wp_config, LOCK_EX );
				} else {
					return new WP_Error( 'broke', __( 'Can\'t make backup. Aborting!', 'wpmr' ) );
				}
			}
		}
	}

	function unpatch_wp_config() {
		$wp_config_path = $this->get_wp_config_path();

		if ( $wp_config_path ) {
			$wp_config     = file_get_contents( $wp_config_path );
			$config_search = $this->get_config_search();
			$waf_enabled   = preg_match( $config_search, $wp_config );
			if ( $waf_enabled ) {
				$wp_config = preg_replace( $config_search, '', $wp_config );
				$this->llog( $wp_config );
				return file_put_contents( $wp_config_path, $wp_config, LOCK_EX );
			}
		}
	}
}

function wp_malware_removal() {
	return WPMR_Init::get_instance();
}

wp_malware_removal();
